VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.OCX"
Begin VB.Form frmTeletext 
   Caption         =   "View File"
   ClientHeight    =   6480
   ClientLeft      =   192
   ClientTop       =   1104
   ClientWidth     =   6936
   Icon            =   "frmTeletext.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6480
   ScaleWidth      =   6936
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   6240
      Top             =   4848
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   6048
      Left            =   144
      OLEDragMode     =   1  'Automatic
      OLEDropMode     =   1  'Manual
      ScaleHeight     =   6000
      ScaleWidth      =   5760
      TabIndex        =   0
      Top             =   132
      Width           =   5808
   End
   Begin MSComDlg.CommonDialog dlgCommonDialog 
      Left            =   6192
      Top             =   5376
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save File..."
      End
      Begin VB.Menu mnuFilePrint 
         Caption         =   "&Print File"
      End
      Begin VB.Menu mnuFileClose 
         Caption         =   "&Close"
      End
   End
End
Attribute VB_Name = "frmTeletext"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim EM7Font(3, 96, 20) As Integer
Dim txtFile() As Byte
Dim gName As String

Dim Mode7FlashOn As Integer
Dim Mode7DoubleHeightFlags(80) As Integer ' Pessimistic size for this flags - if 1 then corresponding character on NEXT line is top half
Dim CurrentLineBottom As Integer
Dim NextLineBottom As Integer

Sub Show_File()

    If Me.Tag = 0 Then ShowMode7

End Sub

Private Sub Form_Unload(Cancel As Integer)

    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "TeletextLeft", Me.Left
        SaveSetting App.Title, "Settings", "TeletextTop", Me.Top
    End If

End Sub

Private Sub mnuFileClose_Click()

    Unload Me
    
End Sub

Private Sub mnuFilePrint_Click()
  
    Printer.PaintPicture Picture1.Image, 0, 0
    Printer.EndDoc
    
End Sub

Private Sub mnuFileSave_Click()

Dim hSend
Dim sNewName As String

    On Error Resume Next
    
    dlgCommonDialog.FileName = gName & ".bmp"
    dlgCommonDialog.DialogTitle = "Save File As"
    dlgCommonDialog.Filter = "Save File (*.BMP)|*.bmp|All Files (*.*)|*.*"
    dlgCommonDialog.CancelError = True
    dlgCommonDialog.ShowSave
    If Err = cdlCancel Then
        Exit Sub
    End If
    
    If dlgCommonDialog.FileName = "" Then
        Exit Sub
    End If
    
    sNewName = dlgCommonDialog.FileName

    SavePicture Picture1.Image, sNewName

End Sub

Private Sub BuildMode7Font()

Dim m7File As Integer
Dim m7cc As Byte
Dim m7cy As Byte
Dim m7cb As Integer
Dim row1 As Integer ' row builders for mode 7 graphics
Dim row2 As Integer
Dim row3 As Integer
Dim TxtFnt As String
Dim flen As Long
Dim I As Integer

 ' Build enhanced mode 7 font
    
    TxtFnt = App.Path & "\teletext.fnt"
    
    If Dir(TxtFnt) = "" Then
        Dim errstr As String
        errstr = "Cannot open Teletext font file teletext.fnt"
        MsgBox errstr, vbOK Or vbCritical, "WindowTitle"
        End
    End If
    
    flen = FileLen(TxtFnt)
    
    m7File = FreeFile
    
    Open TxtFnt For Binary As #m7File
    
' Copy in file

    ReDim txtFile(flen - 1)
    
    Get #m7File, 1, txtFile
    
    Close #m7File
    
    I = 0
    
    For m7cc = 32 To 127
        For m7cy = 0 To 17
            m7cb = txtFile(I)
            I = I + 1
            m7cb = m7cb Or txtFile(I) * 256
            I = I + 1
            EM7Font(0, m7cc - 32, m7cy + 2) = m7cb * 4
            EM7Font(1, m7cc - 32, m7cy + 2) = m7cb * 4
            EM7Font(2, m7cc - 32, m7cy + 2) = m7cb * 4
        Next m7cy
        EM7Font(2, m7cc - 32, 0) = 0
        EM7Font(1, m7cc - 32, 0) = EM7Font(2, m7cc - 32, 0)
        EM7Font(0, m7cc - 32, 0) = EM7Font(1, m7cc - 32, 0)
        EM7Font(2, m7cc - 32, 1) = 0
        EM7Font(1, m7cc - 32, 1) = EM7Font(2, m7cc - 32, 1)
        EM7Font(0, m7cc - 32, 1) = EM7Font(1, m7cc - 32, 1)
    Next m7cc
    
    ' Now fill in the graphics - this is built from an algorithm, but has certain lines/columns
    ' blanked for separated graphics.
    For m7cc = 0 To 95
        ' here's how it works: top two blocks: 1 & 2
        ' middle two blocks: 4 & 8
        ' bottom two blocks: 16 & 64
        ' its only a grpahics character if bit 5 (32) is clear.
        If (m7cc And 32) = 0 Then
            row1 = 0
            row2 = 0
            row3 = 0
            ' left block has a value of 4032, right 63 and both 4095
            If (m7cc And 1) <> 0 Then
                row1 = row1 Or 4032
            End If
            If (m7cc And 2) <> 0 Then
                row1 = row1 Or 63
            End If
            If (m7cc And 4) <> 0 Then
                row2 = row2 Or 4032
            End If
            If (m7cc And 8) <> 0 Then
                row2 = row2 Or 63
            End If
            If (m7cc And 16) <> 0 Then
                row3 = row3 Or 4032
            End If
            If (m7cc And 64) <> 0 Then
                row3 = row3 Or 63
            End If
            ' now input these values into the array
            ' top row of blocks - continuous
            EM7Font(1, m7cc, 2) = row1
            EM7Font(1, m7cc, 1) = EM7Font(1, m7cc, 2)
            EM7Font(1, m7cc, 0) = EM7Font(1, m7cc, 1)
            EM7Font(1, m7cc, 5) = row1
            EM7Font(1, m7cc, 4) = EM7Font(1, m7cc, 5)
            EM7Font(1, m7cc, 3) = EM7Font(1, m7cc, 4)
            ' Separated
            row1 = row1 And 975 ' insert gaps
            EM7Font(2, m7cc, 2) = row1
            EM7Font(2, m7cc, 1) = EM7Font(2, m7cc, 2)
            EM7Font(2, m7cc, 0) = EM7Font(2, m7cc, 1)
            EM7Font(2, m7cc, 3) = row1
            EM7Font(2, m7cc, 5) = 0
            EM7Font(2, m7cc, 4) = EM7Font(2, m7cc, 5)
            ' middle row of blocks - continuous
            EM7Font(1, m7cc, 8) = row2
            EM7Font(1, m7cc, 7) = EM7Font(1, m7cc, 8)
            EM7Font(1, m7cc, 6) = EM7Font(1, m7cc, 7)
            EM7Font(1, m7cc, 11) = row2
            EM7Font(1, m7cc, 10) = EM7Font(1, m7cc, 11)
            EM7Font(1, m7cc, 9) = EM7Font(1, m7cc, 10)
            EM7Font(1, m7cc, 13) = row2
            EM7Font(1, m7cc, 12) = EM7Font(1, m7cc, 13)
            ' Separated
            row2 = row2 And 975 ' insert gaps
            EM7Font(2, m7cc, 8) = row2
            EM7Font(2, m7cc, 7) = EM7Font(2, m7cc, 8)
            EM7Font(2, m7cc, 6) = EM7Font(2, m7cc, 7)
            EM7Font(2, m7cc, 11) = row2
            EM7Font(2, m7cc, 10) = EM7Font(2, m7cc, 11)
            EM7Font(2, m7cc, 9) = EM7Font(2, m7cc, 10)
            EM7Font(2, m7cc, 13) = 0
            EM7Font(2, m7cc, 12) = EM7Font(2, m7cc, 13)
            ' Bottom row - continuous
            EM7Font(1, m7cc, 16) = row3
            EM7Font(1, m7cc, 15) = EM7Font(1, m7cc, 16)
            EM7Font(1, m7cc, 14) = EM7Font(1, m7cc, 15)
            EM7Font(1, m7cc, 19) = row3
            EM7Font(1, m7cc, 18) = EM7Font(1, m7cc, 19)
            EM7Font(1, m7cc, 17) = EM7Font(1, m7cc, 18)
            ' Separated
            row3 = row3 And 975 ' insert gaps
            EM7Font(2, m7cc, 16) = row3
            EM7Font(2, m7cc, 15) = EM7Font(2, m7cc, 16)
            EM7Font(2, m7cc, 14) = EM7Font(2, m7cc, 15)
            EM7Font(2, m7cc, 17) = row3
            EM7Font(2, m7cc, 19) = 0
            EM7Font(2, m7cc, 18) = EM7Font(2, m7cc, 19)
        
        End If ' check for valid char to modify
    
    Next m7cc ' character loop.
    
End Sub ' BuildMode7Font

Private Sub ShowMode7()

Dim CurrentPtr As String
Dim CurrentChar As Integer
Dim XStep As Integer
Dim sbyte As Byte
Dim tmp As Integer

Dim Foreground As Long
Dim ActualForeground As Long
Dim Background As Long
Dim Flash As Integer
Dim DoubleHeight As Integer
Dim Graphics As Integer
Dim Separated As Integer
Dim HoldGraph As Integer
' That's ok. Nobody else does either, and nor do I. - Richard Gellman.
Dim HoldGraphChar
Dim CurrentCol(20) As Long
Dim CurrentLen(20) As Integer
Dim CurrentStartX(20) As Integer
Dim CurrentScanLine As Integer
Dim CurrentX As Integer
Dim CurrentPixel As Integer
Dim col As Long
Dim FontTypeIndex As Integer

Dim cols(7) As Long

Dim I As Integer
Dim flen As Integer
Dim starty As Integer
Dim offset As Integer

Dim size As Long
Dim sector As Long
Dim s As String
Dim o As Long
Dim b As Byte

    Me.Caption = "View Teletext File - " & mSelectedItem.Text

    gName = mSelectedItem.Text
    
    size = Val("&H" & mSelectedItem.SubItems(4) & "#")
    sector = Val("&H" & mSelectedItem.SubItems(5) & "#")
    
    If size > 1024 Then size = 1024
    
    o = sector * 256# + cur_drive * 256# * 10# * 80#
    
    flen = size
    
    If flen = &H3C0 Then
        offset = 0
    Else
        offset = 104
    End If
    
    I = 0
    
    cols(0) = RGB(0, 0, 0)
    cols(1) = RGB(255, 0, 0)
    cols(2) = RGB(0, 255, 0)
    cols(3) = RGB(255, 255, 0)
    cols(4) = RGB(0, 0, 255)
    cols(5) = RGB(255, 0, 255)
    cols(6) = RGB(0, 255, 255)
    cols(7) = RGB(255, 255, 255)
    
    Me.Height = (20 * ((flen - offset) \ 40) + 90) * Screen.TwipsPerPixelY
    
    Picture1.Height = (20 * ((flen - offset) \ 40) + 4) * Screen.TwipsPerPixelY
    
    For starty = 0 To (flen \ 40) - 1
    
    Foreground = cols(7)
    Background = cols(0)
    Flash = 0 ' i.e. steady
    DoubleHeight = 0 ' Normal
    Graphics = 0 ' I.e. alpha
    Separated = 0 ' i.e. continuous graphics
    HoldGraph = 0 ' I.e. don't hold graphics - I don't know what hold graphics is anyway!
    ' That's ok. Nobody else does either, and nor do I. - Richard Gellman.
    HoldGraphChar = 32 ' AHA! we know what it is now, this is the character to "hold" during control codes
  
    For I = 0 To 19
        CurrentLen(I) = 0
        CurrentStartX(I) = 0
        CurrentCol(I) = &HFFFFFF
    Next I
    
    CurrentX = 0
    FontTypeIndex = 0 ' 0=alpha, 1=contiguous graphics, 2=separated graphics
  
    XStep = 1

    For CurrentChar = 0 To 39
        
        sbyte = DiscImg(o + CurrentChar + starty * 40 + offset)
        
        If sbyte < 32 Then ' fix for naughty programs that use 7-bit control codes - Richard Gellman
            sbyte = sbyte + 128
        End If
        
        If ((sbyte And 32) <> 0) And (Graphics = 1) Then
            HoldGraphChar = sbyte
        End If
        
        If (sbyte >= 128) And (sbyte <= 159) Then
            Select Case sbyte
            Case 129, 130, 131, 132, 133, 134, 135
                Foreground = cols(sbyte - 128)
                Graphics = 0

            Case 136
                Flash = 1

            Case 137
                Flash = 0

            Case 140
                DoubleHeight = 0

            Case 141
                If CurrentLineBottom = 0 Then
                    NextLineBottom = 1
                End If
                DoubleHeight = 1

            Case 145, 146, 147, 148, 149, 150, 151
                Foreground = cols(sbyte - 144)
                Graphics = 1

            Case 152 ' Conceal display - not sure about this
                Foreground = Background

            Case 153
                Separated = 0

            Case 154
                Separated = 1

            Case 156
                Background = cols(0)

            Case 157
                Background = Foreground

            Case 158
                HoldGraph = 1

            Case 159
                HoldGraph = 0
            
            End Select ' Special character switch
        
      ' This next line hides any non double height characters on the bottom line
      ' Fudge so that the special character is just displayed in background
      
            If (HoldGraph = 1) And (Graphics = 1) Then
                sbyte = HoldGraphChar
            Else
                sbyte = 32
            End If
             
            If Graphics Then
                If Separated Then
                    FontTypeIndex = 2
                Else
                    FontTypeIndex = 1
                End If
            Else
                FontTypeIndex = 0
            End If
            
        End If  ' test for special character
      
        If (CurrentLineBottom = 1) And ((sbyte And 127) > 31) And ((DoubleHeight = 0)) Then
            sbyte = 32
        End If
        
        ' Top bit never reaches character generator
        sbyte = sbyte And 127
        ' Our font table goes from character 32 up
    
        If sbyte < 32 Then
            sbyte = 0
        Else
            sbyte = sbyte - 32
        End If

        ' Conceal flashed text if necessary
        If ((Flash = 1) And (Mode7FlashOn = 0)) Then
            ActualForeground = Background
        Else
            ActualForeground = Foreground
        End If
        
        If (DoubleHeight = 0) Then
            For CurrentScanLine = 0 To 19
                tmp = EM7Font(FontTypeIndex, sbyte, CurrentScanLine)
                'tmp=1365;
                If (tmp = 0) Or (tmp = 255) Then
                    
                    If (tmp = 0) Then
                        col = Background
                    Else
                        col = ActualForeground
                    End If
                    
                    If col = CurrentCol(CurrentScanLine) Then
                        CurrentLen(CurrentScanLine) = CurrentLen(CurrentScanLine) + 12 * XStep
                    Else
                    
                        If CurrentLen(CurrentScanLine) Then
                            doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
                        End If
                        CurrentCol(CurrentScanLine) = col
                        CurrentStartX(CurrentScanLine) = CurrentX
                        CurrentLen(CurrentScanLine) = 12 * XStep

                    End If ' same colour
                
                Else
                
                    CurrentPixel = &H800
                    
                    Do While CurrentPixel
                        
                        ' Background or foreground ?
                        If (tmp And CurrentPixel) <> 0 Then
                            col = ActualForeground
                        Else
                            col = Background
                        End If

                        ' Do we need to draw ?
                        If col = CurrentCol(CurrentScanLine) Then
                            CurrentLen(CurrentScanLine) = CurrentLen(CurrentScanLine) + XStep
                        Else
                            If CurrentLen(CurrentScanLine) Then
                                doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
                            End If
                        
                            CurrentCol(CurrentScanLine) = col
                            CurrentStartX(CurrentScanLine) = CurrentX
                            CurrentLen(CurrentScanLine) = XStep
                        
                        End If ' Fore/back ground
                
                        CurrentX = CurrentX + XStep
                        CurrentPixel = CurrentPixel \ 2
                    
                    Loop ' Pixel within byte
                    
                    CurrentX = CurrentX - 12 * XStep
                    
                End If ' tmp!=0
                
            Next CurrentScanLine ' Scanline for
            
            CurrentX = CurrentX + 12 * XStep
            
            Mode7DoubleHeightFlags(CurrentChar) = 1 ' Not double height - so if the next line is double height it will be top half
        
        Else
        
            Dim ActualScanLine As Integer
            ' Double height!
            
            CurrentPixel = &H800
            
            Do While CurrentPixel
            
                For CurrentScanLine = 0 To 19
                    
                    If (CurrentLineBottom = 0) Then
                        ActualScanLine = CurrentScanLine \ 2
                    Else
                        ActualScanLine = 10 + (CurrentScanLine \ 2)
                    End If
                    
                    ' Background or foreground ?
                    If (EM7Font(FontTypeIndex, sbyte, ActualScanLine) And CurrentPixel) <> 0 Then
                        col = ActualForeground
                    Else
                        col = Background
                    End If

                    ' Do we need to draw ?
                    If col = CurrentCol(CurrentScanLine) Then
                        CurrentLen(CurrentScanLine) = CurrentLen(CurrentScanLine) + XStep
                    Else
                        
                        If CurrentLen(CurrentScanLine) Then
                            doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
                        End If
                        
                        CurrentCol(CurrentScanLine) = col
                        CurrentStartX(CurrentScanLine) = CurrentX
                        CurrentLen(CurrentScanLine) = XStep
                        
                    End If ' Fore/back ground
                    
                Next CurrentScanLine ' Scanline for
                
                CurrentX = CurrentX + XStep
                
                CurrentPixel = CurrentPixel \ 2
                
            Loop ' Pixel within byte
            
            Mode7DoubleHeightFlags(CurrentChar) = Mode7DoubleHeightFlags(CurrentChar) Xor 1 ' Not double height - so if the next line is double height it will be top half
            
        End If
        
    Next CurrentChar

    ' Finish off right bits of scan line
    For CurrentScanLine = 0 To 19
        
        If CurrentLen(CurrentScanLine) Then
            doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
        End If
    
    Next CurrentScanLine
    
    CurrentLineBottom = NextLineBottom
    NextLineBottom = 0

    Next starty
    
End Sub

Private Sub doHorizLine(col As Long, scan As Integer, start As Integer, xlen As Integer)

'   Debug.Print col, scan, start, xlen

    Picture1.Line (start, scan)-(start + xlen, scan), col

'    Sleep 10

 '   DoEvents


End Sub

Private Sub Form_Load()

    Me.Left = GetSetting(App.Title, "Settings", "TeletextLeft", 84)
    Me.Top = GetSetting(App.Title, "Settings", "TeletextTop", 84)
    
    BuildMode7Font

    Me.width = (480 + 40) * Screen.TwipsPerPixelX
    Me.Height = (500 + 90) * Screen.TwipsPerPixelY
    
    Picture1.width = (480 + 4) * Screen.TwipsPerPixelX
    Picture1.Height = (500 + 4) * Screen.TwipsPerPixelY
    
    Picture1.Top = 10 * Screen.TwipsPerPixelY
    Picture1.Left = 10 * Screen.TwipsPerPixelX
    
    Picture1.ScaleMode = 3
    
    Mode7FlashOn = 0
    
    Timer1.Enabled = True

End Sub

Private Sub Timer1_Timer()

    Mode7FlashOn = Mode7FlashOn Xor 1 ' True if a flashing character in mode 7 is on
    CurrentLineBottom = 0
    NextLineBottom = 0 ' 1 if the next line of double height should be bottoms only
    
    ShowMode7

End Sub

